-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicHeals"] = q.modules["QoL_ClassicHeals"] or {};
local c = q.modules["QoL_ClassicHeals"];

local oldValues = {};

local profiles, profileOrder;
local profileFrame;

local chShowOverheal;
local lblProfile, cbProfile, chIsProfileEnabled;
local lblFontSize, sldFontSize;
local lblFontSizeCritical, sldFontSizeCritical;
local lblXOffset, sldXOffset;
local lblYOffset, sldYOffset;
local btnReset, btnResetAll;
local lblFontColor, lblFontColorSample, lblFontColorCritical, lblFontColorCriticalSample, lblFontColorOverheal, lblFontColorOverhealSample;
local lblFontColorR, sldFontColorR, sldFontColorCriticalR, sldFontColorOverhealR;
local lblFontColorG, sldFontColorG, sldFontColorCriticalG, sldFontColorOverhealG;
local lblFontColorB, sldFontColorB, sldFontColorCriticalB, sldFontColorOverhealB;
local lblFontColorA, sldFontColorA, sldFontColorCriticalA, sldFontColorOverhealA;

local spacings, spacingIndex = {};
local sldFontColorXOffset, sldFontColorCriticalXOffset, sldFontColorOverhealXOffset = 55, 240, 425;

function c:InitOptions()
	QOL_OPTIONS = QOL_OPTIONS or {};
	QOL_OPTIONS[c.name] = QOL_OPTIONS[c.name] or {};

	c.OPT_UI_LASTPROFILE = "OPT_UI_LASTPROFILE";

	-- profiles
	c.PROFILE_PLAYER = "PROFILE_PLAYER";
	c.PROFILE_TARGET = "PROFILE_TARGET";
	c.PROFILE_PARTY = "PROFILE_PARTY";
	c.PROFILE_RAID_COMPACT = "PROFILE_RAID_COMPACT";
	c.PROFILE_RAID_PULLOUT = "PROFILE_RAID_PULLOUT";

	c.PROFILE_ADDON_GRID2 = "PROFILE_ADDON_GRID2";
	c.PROFILE_ADDON_VUHDO = "PROFILE_ADDON_VUHDO";

	-- attributes
	c.OPT_UIATTR_ENABLED = "OPT_UIATTR_ENABLED";
	c.OPT_UIATTR_FONTSIZE = "OPT_UIATTR_FONTSIZE";
	c.OPT_UIATTR_FONTSIZE_CRITICAL = "OPT_UIATTR_FONTSIZE_CRITICAL";
	c.OPT_UIATTR_FONTCOLOR = "OPT_UIATTR_FONTCOLOR";	
	c.OPT_UIATTR_FONTCOLOR_CRITICAL = "OPT_UIATTR_FONTCOLOR_CRITICAL";
	c.OPT_UIATTR_FONTCOLOR_OVERHEAL = "OPT_UIATTR_FONTCOLOR_OVERHEAL";
	c.OPT_UIATTR_XOFFSET = "OPT_UIATTR_XOFFSET";
	c.OPT_UIATTR_YOFFSET = "OPT_UIATTR_YOFFSET";
	c.OPT_UIATTR_SHOWOVERHEAL = "OPT_SHOWOVERHEAL";

	profiles = profiles or {
		[c.PROFILE_PLAYER] = q:GetText("             Player Frame"),
		[c.PROFILE_TARGET] = q:GetText("             Target Frame"),
		[c.PROFILE_PARTY] = q:GetText("[2-5]    Party Frames"),
		[c.PROFILE_RAID_COMPACT] = q:GetText("[2-40] Compact Raid Frames"),
		[c.PROFILE_RAID_PULLOUT] = q:GetText("[2-40] Raid Pullout Groups"),
		[c.PROFILE_ADDON_GRID2] = q:GetText("[1-40] Addon: Grid2"),
		[c.PROFILE_ADDON_VUHDO] = q:GetText("[1-40] Addon: Vuhdo")
	};

	if not profileOrder then
		profileOrder = {};
		table.insert(profileOrder, c.PROFILE_PLAYER);
		table.insert(profileOrder, c.PROFILE_TARGET);
		table.insert(profileOrder, c.PROFILE_PARTY);
		table.insert(profileOrder, c.PROFILE_RAID_COMPACT);
		table.insert(profileOrder, c.PROFILE_RAID_PULLOUT);
		table.insert(profileOrder, c.PROFILE_ADDON_GRID2);
		table.insert(profileOrder, c.PROFILE_ADDON_VUHDO);
	end

	-- default values
	for profile in pairs(profiles) do
		QOL_OPTIONS[c.name][profile] = QOL_OPTIONS[c.name][profile] or {};
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR] or {};
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["r"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["r"] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["g"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["g"] or 1;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["b"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["b"] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["a"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR]["a"] or 1;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL] or {};
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["r"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["r"] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["g"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["g"] or 1;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["b"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["b"] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["a"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["a"] or 1;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL] or {};
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["r"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["r"] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["g"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["g"] or 1;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["b"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["b"] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["a"] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["a"] or 1;

		if QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_ENABLED] == nil then
			QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_ENABLED] = true;
		end

		if QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_SHOWOVERHEAL] == nil then
			QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_SHOWOVERHEAL] = true;
		end
	end

	QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_XOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_XOFFSET] or -41;
	QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_YOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_YOFFSET] or 6;
	QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_FONTSIZE] = QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_FONTSIZE] or 16;
	QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_FONTSIZE_CRITICAL] = QOL_OPTIONS[c.name][c.PROFILE_PLAYER][c.OPT_UIATTR_FONTSIZE_CRITICAL] or 20;

	QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_XOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_XOFFSET] or 41;
	QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_YOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_YOFFSET] or 6;
	QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_FONTSIZE] = QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_FONTSIZE] or 16;
	QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_FONTSIZE_CRITICAL] = QOL_OPTIONS[c.name][c.PROFILE_TARGET][c.OPT_UIATTR_FONTSIZE_CRITICAL] or 20;

	QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_XOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_XOFFSET] or 0;
	QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_YOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_YOFFSET] or -2;
	QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_FONTSIZE] = QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_FONTSIZE] or 16;
	QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_FONTSIZE_CRITICAL] = QOL_OPTIONS[c.name][c.PROFILE_PARTY][c.OPT_UIATTR_FONTSIZE_CRITICAL] or 20;

	QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_XOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_XOFFSET] or 0;
	QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_YOFFSET] = QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_YOFFSET] or -2;
	QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_FONTSIZE] = QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_FONTSIZE] or 12;
	QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_FONTSIZE_CRITICAL] = QOL_OPTIONS[c.name][c.PROFILE_RAID_PULLOUT][c.OPT_UIATTR_FONTSIZE_CRITICAL] or 16;

	for profile in pairs(profiles) do
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_XOFFSET] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_XOFFSET] or 0;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_YOFFSET] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_YOFFSET] or -4;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTSIZE] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTSIZE] or 12;
		QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTSIZE_CRITICAL] = QOL_OPTIONS[c.name][profile][c.OPT_UIATTR_FONTSIZE_CRITICAL] or 16;
	end

	QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE] = QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE] or c.PROFILE_TARGET;

	-- optionsPanel init
	if not c.optionsPanel then
		c.optionsPanel = CreateFrame("Frame", "QoLOptionsFrame_ClassicHeals", q.optionsPanel);
		c.optionsPanel.name = "ClassicHeals";
		c.optionsPanel.parent = q.optionsPanel.name;
		c.optionsPanel.cancel = function(self) c:RevertSettingsChanges(); end;
		InterfaceOptions_AddCategory(c.optionsPanel);
		c.optionsPanel:SetScript("OnShow", function()
			c:ShowOptionsPanel();
		end);

		local S = q:GetElvUiSkinModule();
		if S then
			S:HandleFrame(c.optionsPanel);
		end

		c:ShowOptionsPanel();
	end
end

function c:ShowOptionsPanel()
	spacingIndex, oldValues = 1, q:Deepcopy(QOL_OPTIONS[c.name]);

	if not lblProfile then
		lblProfile = q:CreateOptionsLabel(c.optionsPanel, q:GetText("Profile:"));
	end
	if not cbProfile then
		cbProfile = q:CreateOptionsDropdown(c.optionsPanel, function(self, level, menuList)
			local info = UIDropDownMenu_CreateInfo();
			info.hasArrow = false;
			info.notCheckable  = true;
			info.func = function(self)
				c:cbProfile_SetValue(self.value);
				CloseDropDownMenus();
			end;

			if (level or 1) == 1 then
				for index, profile in ipairs(profileOrder) do
					info.text = profiles[profile];
					info.value = profile;
					UIDropDownMenu_AddButton(info);
				end
			end
		end, 0, true);
	end
	c:cbProfile_SetValue(QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE]);

	if not chIsProfileEnabled then
		chIsProfileEnabled = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Enabled"), function(self)
			QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_ENABLED] = self:GetChecked();
			c:SetProfileValues();
		end, 185);
	end
	chIsProfileEnabled:SetChecked(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_ENABLED]);

	if not profileFrame then
		profileFrame = q:CreateOptionsChildFrame(c.optionsPanel, 0);
	end

	-- xOffset
	if not lblXOffset then
		lblXOffset = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldXOffset then
		sldXOffset = q:CreateOptionsSlider(profileFrame, -50, 50, function(self) c:SldXOffset_ValueChanged(self) end, 180, 1, false, true);
	end

	-- yOffset
	if not lblYOffset then
		lblYOffset = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldYOffset then
		sldYOffset = q:CreateOptionsSlider(profileFrame, -50, 50, function(self) c:SldYOffset_ValueChanged(self) end, 180, 1, false, true);
	end

	c:InsertSpacing();

	-- fontsize
	if not lblFontSize then
		lblFontSize = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldFontSize then
		sldFontSize = q:CreateOptionsSlider(profileFrame, 10, 30, function(self) c:SldFontSize_ValueChanged(self) end, 180, 1, false, true);
	end

	-- fontsize (critical)
	if not lblFontSizeCritical then
		lblFontSizeCritical = q:CreateOptionsLabel(profileFrame, nil, 0, true);
	end
	if not sldFontSizeCritical then
		sldFontSizeCritical = q:CreateOptionsSlider(profileFrame, 10, 30, function(self) c:SldFontSizeCritical_ValueChanged(self) end, 180, 1, true, true);
	end

	-- show overheal
	if not chShowOverheal then
		chShowOverheal = q:CreateOptionsCheckbox(profileFrame, q:GetText("Show overheal"), function(self)
			QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_SHOWOVERHEAL] = self:GetChecked();
			c:ShowOverhealVisualOptions(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_SHOWOVERHEAL]);
		end, sldFontColorOverhealXOffset + 5);
	end

	c:InsertSpacing();

	-- fontcolor
	if not lblFontColor then
		lblFontColor = q:CreateOptionsLabel(profileFrame, q:GetText("Font Color:"), sldFontColorXOffset, true);
	end
	if not lblFontColorSample then
		lblFontColorSample = q:CreateOptionsLabel(profileFrame, q:GetText("+1112"), 180, true);
	end
	if not lblFontColorCritical then
		lblFontColorCritical = q:CreateOptionsLabel(profileFrame, q:GetText("Font Color (critical):"), sldFontColorCriticalXOffset, true);
	end
	if not lblFontColorCriticalSample then
		lblFontColorCriticalSample = q:CreateOptionsLabel(profileFrame, q:GetText("+1112"), 365, true);
	end
	if not lblFontColorOverheal then
		lblFontColorOverheal = q:CreateOptionsLabel(profileFrame, nil, sldFontColorOverhealXOffset, true);
	end
	if not lblFontColorOverhealSample then
		lblFontColorOverhealSample = q:CreateOptionsLabel(profileFrame, nil, 550);
	end

	if not lblFontColorR then
		lblFontColorR = q:CreateOptionsLabel(profileFrame, q:GetText("Red"), 0, true);
	end
	if not sldFontColorR then
		sldFontColorR = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, 0, true, true);
		sldFontColorR.profile, sldFontColorR.col = c.OPT_UIATTR_FONTCOLOR, "r";
	end
	if not sldFontColorCriticalR then
		sldFontColorCriticalR = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, 0, true, true);
		sldFontColorCriticalR.profile, sldFontColorCriticalR.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "r";
	end
	if not sldFontColorOverhealR then
		sldFontColorOverhealR = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, 0, false, true);
		sldFontColorOverhealR.profile, sldFontColorOverhealR.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "r";
	end

	if not lblFontColorG then
		lblFontColorG = q:CreateOptionsLabel(profileFrame, q:GetText("Green"), 0, true);
	end
	if not sldFontColorG then
		sldFontColorG = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, 0, true, true);
		sldFontColorG.profile, sldFontColorG.col = c.OPT_UIATTR_FONTCOLOR, "g";
	end
	if not sldFontColorCriticalG then
		sldFontColorCriticalG = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, 0, true, true);
		sldFontColorCriticalG.profile, sldFontColorCriticalG.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "g";
	end
	if not sldFontColorOverhealG then
		sldFontColorOverhealG = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, 0, false, true);
		sldFontColorOverhealG.profile, sldFontColorOverhealG.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "g";
	end

	if not lblFontColorB then
		lblFontColorB = q:CreateOptionsLabel(profileFrame, q:GetText("Blue"), 0, true);
	end
	if not sldFontColorB then
		sldFontColorB = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, 0, true, true);
		sldFontColorB.profile, sldFontColorB.col = c.OPT_UIATTR_FONTCOLOR, "b";
	end
	if not sldFontColorCriticalB then
		sldFontColorCriticalB = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, 0, true, true);
		sldFontColorCriticalB.profile, sldFontColorCriticalB.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "b";
	end
	if not sldFontColorOverhealB then
		sldFontColorOverhealB = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, 0, false, true);
		sldFontColorOverhealB.profile, sldFontColorOverhealB.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "b";
	end

	if not lblFontColorA then
		lblFontColorA = q:CreateOptionsLabel(profileFrame, q:GetText("Alpha"), 0, true);
	end
	if not sldFontColorA then
		sldFontColorA = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorXOffset, 0, true, true);
		sldFontColorA.profile, sldFontColorA.col = c.OPT_UIATTR_FONTCOLOR, "a";
	end
	if not sldFontColorCriticalA then
		sldFontColorCriticalA = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorCriticalXOffset, 0, true, true);
		sldFontColorCriticalA.profile, sldFontColorCriticalA.col = c.OPT_UIATTR_FONTCOLOR_CRITICAL, "a";
	end
	if not sldFontColorOverhealA then
		sldFontColorOverhealA = q:CreateOptionsSlider(profileFrame, 0, 1, function(self) c:SldColor_ValueChanged(self); end, sldFontColorOverhealXOffset, 0, false, true);
		sldFontColorOverhealA.profile, sldFontColorOverhealA.col = c.OPT_UIATTR_FONTCOLOR_OVERHEAL, "a";
	end

	c:InsertSpacing();

	-- reset
	if not btnReset then
		btnReset = q:CreateOptionsButton(profileFrame, q:GetText("Reset"), function()
			QOL_OPTIONS[c.name][cbProfile.value] = {};
			c:InitOptions();
			c:SetProfileValues();
		end);
	end

	c:InsertSpacing();

	-- reset all
	if not btnResetAll then
		btnResetAll = q:CreateOptionsButton(profileFrame, q:GetText("Reset all"), function()
			c:ShowResetDialog();
		end);
	end

	c:SetProfileValues();
end

function c:InsertSpacing()
	if not spacings[spacingIndex] then
		spacings[spacingIndex] = q:CreateOptionsSpacing(profileFrame);
	end
	spacingIndex = spacingIndex + 1;
end

function c:cbProfile_SetValue(value)
	cbProfile.value = value;
	cbProfile:SetText(profiles[value]);

	if c.initFinished then
		chIsProfileEnabled:SetChecked(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_ENABLED]);
		c:SetProfileValues();
		QOL_OPTIONS[c.name][c.OPT_UI_LASTPROFILE] = cbProfile.value;
	end
end

function c:SetProfileValues()
	if QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_ENABLED] then
		profileFrame:Show();

		lblXOffset:SetText(q:GetText("X Offset: %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_XOFFSET]));
		sldXOffset:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_XOFFSET]);
		lblYOffset:SetText(q:GetText("Y Offset: %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_YOFFSET]));
		sldYOffset:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_YOFFSET]);

		lblFontSize:SetText(q:GetText("Font Size: %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE]));
		sldFontSize:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE]);
		sldFontSizeCritical:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE_CRITICAL]);
		lblFontSizeCritical:SetText(q:GetText("Font Size (critical): %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE_CRITICAL]));

		lblFontColorSample:SetTextColor(q:GetColorRBGA(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR]));
		sldFontColorR:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR]["r"]);
		sldFontColorG:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR]["g"]);
		sldFontColorB:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR]["b"]);
		sldFontColorA:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR]["a"]);

		lblFontColorCriticalSample:SetTextColor(q:GetColorRBGA(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_CRITICAL]));
		sldFontColorCriticalR:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["r"]);
		sldFontColorCriticalG:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["g"]);
		sldFontColorCriticalB:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["b"]);
		sldFontColorCriticalA:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_CRITICAL]["a"]);

		lblFontColorOverhealSample:SetTextColor(q:GetColorRBGA(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]));
		sldFontColorOverhealR:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["r"]);
		sldFontColorOverhealG:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["g"]);
		sldFontColorOverhealB:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["b"]);
		sldFontColorOverhealA:SetValue(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]["a"]);

		chShowOverheal:SetChecked(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_SHOWOVERHEAL]);
		c:ShowOverhealVisualOptions(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_SHOWOVERHEAL]);
	else
		profileFrame:Hide();
	end
end

function c:ShowOverhealVisualOptions(value)
	if value then
		lblFontColorOverheal:SetText("Font Color (overheal):");
		lblFontColorOverhealSample:SetText("(1112)");
		lblFontColorOverhealSample:SetXOffset(560);
	else
		lblFontColorOverheal:SetText("Font Color (full):");
		lblFontColorOverhealSample:SetText(q:GetText("full"));
		lblFontColorOverhealSample:SetXOffset(575);
	end
end

function c:SldFontSize_ValueChanged(self)
	if c.initFinished then
		QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE] = self:GetValue();
		lblFontSize:SetText(q:GetText("Font Size: %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE]));
	end
end

function c:SldFontSizeCritical_ValueChanged(self)
	if c.initFinished then
		QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE_CRITICAL] = self:GetValue();
		lblFontSizeCritical:SetText(q:GetText("Font Size (critical): %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTSIZE_CRITICAL]));
	end
end

function c:SldXOffset_ValueChanged(self)
	if c.initFinished then
		QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_XOFFSET] = self:GetValue();
		lblXOffset:SetText(q:GetText("X Offset: %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_XOFFSET]));
	end
end

function c:SldYOffset_ValueChanged(self)
	if c.initFinished then
		QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_YOFFSET] = self:GetValue();
		lblYOffset:SetText(q:GetText("Y Offset: %s px", QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_YOFFSET]));
	end
end

function c:SldColor_ValueChanged(self)
	if c.initFinished then
		QOL_OPTIONS[c.name][cbProfile.value][self.profile][self.col] = self:GetValue();
		if self.profile == c.OPT_UIATTR_FONTCOLOR then
			lblFontColorSample:SetTextColor(q:GetColorRBGA(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR]));
		elseif self.profile == c.OPT_UIATTR_FONTCOLOR_CRITICAL then
			lblFontColorCriticalSample:SetTextColor(q:GetColorRBGA(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_CRITICAL]));
		elseif self.profile == c.OPT_UIATTR_FONTCOLOR_OVERHEAL then
			lblFontColorOverhealSample:SetTextColor(q:GetColorRBGA(QOL_OPTIONS[c.name][cbProfile.value][c.OPT_UIATTR_FONTCOLOR_OVERHEAL]));
		end
	end
end

function c:RevertSettingsChanges()
	QOL_OPTIONS[c.name] = oldValues;
end

function c:SaveSettingsChanges()
	oldValues = q:Deepcopy(QOL_OPTIONS[c.name]);
end